=== debian/changelog ===
ros-foxy-rmf-traffic (1.4.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Grey <grey@openrobotics.org>  Fri, 10 Sep 2021 04:17:04 -0000
